"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var TabComponent = /** @class */ (function () {
    function TabComponent(resolver, router) {
        this.resolver = resolver;
        this.router = router;
        this.tabChangeEvent = new core_1.EventEmitter();
    }
    Object.defineProperty(TabComponent.prototype, "tabDatas", {
        get: function () {
            return this._tabDatas;
        },
        set: function (v) {
            this._tabDatas = v;
            this.init();
        },
        enumerable: true,
        configurable: true
    });
    TabComponent.prototype.ngOnInit = function () {
    };
    TabComponent.prototype.init = function () {
        if (this.tabDatas == null && this.tabDatas.length == 0) {
            this.dyComponent.clear();
            return;
        }
        this.dyComponent.clear();
        for (var _i = 0, _a = this.tabDatas; _i < _a.length; _i++) {
            var tab = _a[_i];
            if (tab.select) {
                this.nowSelectTab = tab;
            }
        }
        if (this.nowSelectTab == null) {
            this.nowSelectTab = this.tabDatas[0];
        }
        if (this.nowSelectTab.component) {
            var component = this.resolver.resolveComponentFactory(this.nowSelectTab.component);
            this.ref = this.dyComponent.createComponent(component);
            if (this.nowSelectTab.data) {
                var instance = this.ref.instance;
                instance.data = this.nowSelectTab.data;
            }
        }
        if (this.nowSelectTab.url) {
            var params = this.nowSelectTab.params == null ? {} : this.nowSelectTab.params;
            this.router.navigate([this.nowSelectTab.url], { queryParams: params });
        }
    };
    /*  ngOnChanges(changes: SimpleChanges) {
        if (changes.tabDatas && !changes.tabDatas.firstChange) {
          this.init();
        }
      }*/
    TabComponent.prototype.changeTab = function (tab) {
        for (var _i = 0, _a = this.tabDatas; _i < _a.length; _i++) {
            var d = _a[_i];
            d.select = false;
        }
        tab.select = true;
        this.nowSelectTab = tab;
        this.init();
        this.tabChangeEvent.emit(tab);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TabComponent.prototype, "tabDatas", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TabComponent.prototype, "tabChangeEvent", void 0);
    __decorate([
        core_1.ViewChild('dyComponent', { read: core_1.ViewContainerRef }),
        __metadata("design:type", core_1.ViewContainerRef)
    ], TabComponent.prototype, "dyComponent", void 0);
    TabComponent = __decorate([
        core_1.Component({
            selector: 'dc-tab',
            template: "\n  <div class=\"display-flex width-100 flex-direction-column\">\n    <div class=\"display-flex width-100 tabs\">\n        <div *ngFor=\"let d of tabDatas\">\n            <div class=\"title\" (click)=\"changeTab(d)\" [ngClass]=\"{'active':d.select}\">\n                <div *ngIf=\"d.icon\" class=\"icon\"><img src=\"{{d.icon}}\"></div>\n                <div>{{d.title}}</div>\n                <i *ngIf=\"d.notify && d.notify>0\" [ngStyle]=\"{'background-color':d.notifyColor}\">{{d.notify}}</i>\n            </div>\n        </div>\n    </div>\n    <div #dyComponent class=\"width-100\"></div>\n  </div>",
            styles: [
                '.tabs {' +
                    'padding: 15px 20px 0;' +
                    'border-bottom: solid 1px #d6d6d6}',
                '.tabs>div {' +
                    'margin-right: 70px}',
                '.title {' +
                    'cursor: pointer;' +
                    'display: table;' +
                    'position: relative;' +
                    'bottom: 0;' +
                    'font-size: 18px;' +
                    'height: 36px;' +
                    'color: #666;}',
                '.title.active {' +
                    'font-weight: bold;' +
                    'color: #333;' +
                    'border-bottom: solid 2px #333;' +
                    'bottom: -1px;}',
                '.title>div {' +
                    'display: table-cell;' +
                    'vertical-align: middle;}',
                '.title.active>div {' +
                    'padding-bottom: 3px}',
                '.title>div.icon {' +
                    'padding: 0 10px 5px 0}',
                '.title>i {' +
                    'font-size: 10px;' +
                    'font-weight: 400;' +
                    'position: absolute;' +
                    'left: calc(100% + 7px);' +
                    'top: 10px;' +
                    'display: block;' +
                    'padding: 0 8px;' +
                    'line-height: 14px;' +
                    'height: 16px;' +
                    'color: #fff;' +
                    'border-radius: 10px;' +
                    'font-style: normal}',
                '.title.active>i {' +
                    '  top: 9px' +
                    '}'
            ]
        }),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, router_1.Router])
    ], TabComponent);
    return TabComponent;
}());
exports.TabComponent = TabComponent;
//# sourceMappingURL=tab.component.js.map