"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var TableComponent = /** @class */ (function () {
    function TableComponent(router) {
        this.router = router;
        this.checkBox = false;
        this.sortEvent = new core_1.EventEmitter();
        this.checkEvent = new core_1.EventEmitter();
        this.nowSort = {};
        this.allSelect = false;
        this.checks = [];
        this.checks_data = [];
        this.showFilter = [];
    }
    Object.defineProperty(TableComponent.prototype, "datas", {
        get: function () {
            return this._datas;
        },
        set: function (v) {
            this.allSelect = false;
            this._datas = v;
            this.initCheck();
        },
        enumerable: true,
        configurable: true
    });
    TableComponent.prototype.ngOnInit = function () {
        this.initWidth = this.tableContainer.nativeElement.offsetWidth;
        // this.initCheck();
    };
    TableComponent.prototype.setWidth = function (width) {
        if (width && width.indexOf('%') > 0) {
            return parseInt(width) / 100 * this.initWidth + 'px';
        }
        else {
            return width;
        }
    };
    TableComponent.prototype.initCheck = function () {
        this.checks = [];
        for (var _i = 0, _a = this.datas; _i < _a.length; _i++) {
            var d = _a[_i];
            this.checks.push(false);
        }
    };
    TableComponent.prototype.ngAfterContentInit = function () { };
    /*
      ngOnChanges(changes: SimpleChanges): void {
        if (changes.datas && !changes.datas.firstChange) {
          this.allSelect = false;
          this.datas = changes.datas.currentValue;
          this.initCheck();
        }
      }*/
    TableComponent.prototype.allSelectCheck = function () {
        this.checks = [];
        for (var _i = 0, _a = this.datas; _i < _a.length; _i++) {
            var d = _a[_i];
            this.checks.push(this.allSelect);
        }
        this.sendCheckEvent();
    };
    TableComponent.prototype.checkSelect = function () {
        var allTrue = true;
        for (var _i = 0, _a = this.checks; _i < _a.length; _i++) {
            var c = _a[_i];
            if (!c) {
                allTrue = false;
            }
        }
        if (allTrue) {
            this.allSelect = true;
        }
        else {
            this.allSelect = false;
        }
        this.sendCheckEvent();
    };
    TableComponent.prototype.checkOption = function (event, k, header) {
        header.filter.optionList[k].check = event;
    };
    TableComponent.prototype.sendCheckOption = function (header) {
        var result = header.filter.optionList.filter(function (item) { return item.check; });
        header.filter.fn(result);
    };
    TableComponent.prototype.sendCheckEvent = function () {
        this.checks_data = [];
        for (var i = 0; i < this.datas.length; i++) {
            if (this.checks[i]) {
                this.checks_data.push(this.datas[i]);
            }
        }
        this.checkEvent.emit(this.checks_data);
    };
    TableComponent.prototype.sort = function (header) {
        var _this = this;
        if (!header.canSort) {
            return;
        }
        if (this.nowSort.field == header.field) {
            if (this.nowSort.sort == 'asc') {
                this.nowSort.sort = 'desc';
            }
            else {
                this.nowSort.sort = 'asc';
            }
        }
        else {
            this.nowSort.field = header.field;
            this.nowSort.sort = 'desc';
        }
        if (this.sortEvent.observers.length) {
            this.sortEvent.emit(this.nowSort);
        }
        else {
            this.datas.sort(function (a, b) {
                var result = _this.nowSort.sort === 'asc' ? a[_this.nowSort.field] > b[_this.nowSort.field] : b[_this.nowSort.field] > a[_this.nowSort.field];
                return result ? 1 : 0;
            });
        }
    };
    TableComponent.prototype.showFilterBox = function (event, header) {
        event.stopPropagation();
        event.preventDefault();
        var filterBoxDom = event.target.nextElementSibling;
        filterBoxDom.style.display = 'block';
        this.showFilter.push(filterBoxDom);
        this.currentField = header.field;
    };
    TableComponent.prototype.clickFilter = function (event, header) {
        header.filter.fn(event.target.value);
        var filterBoxDom = event.target.parentNode;
        filterBoxDom.style.display = 'none';
    };
    TableComponent.prototype.onDocumentClick = function ($event) {
        var current = $event.target;
        for (var i = 0; i < this.showFilter.length; i++) {
            if (current.parentNode !== this.showFilter[i] && current !== this.showFilter[i].prevElementSibling && current !== this.showFilter[i])
                this.showFilter[i].style.display = 'none';
        }
    };
    __decorate([
        core_1.ContentChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], TableComponent.prototype, "template", void 0);
    __decorate([
        core_1.ViewChild('filterTemplate'),
        __metadata("design:type", Object)
    ], TableComponent.prototype, "filterTemplate", void 0);
    __decorate([
        core_1.ViewChild('table'),
        __metadata("design:type", core_1.ElementRef)
    ], TableComponent.prototype, "tableContainer", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], TableComponent.prototype, "headers", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableComponent.prototype, "datas", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TableComponent.prototype, "checkBox", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TableComponent.prototype, "sortEvent", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TableComponent.prototype, "checkEvent", void 0);
    __decorate([
        core_1.HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], TableComponent.prototype, "onDocumentClick", null);
    TableComponent = __decorate([
        core_1.Component({
            selector: 'dc-table',
            template: "<table class=\"table\" #table>\n      <thead>\n        <tr>\n          <th *ngIf=\"checkBox\">\n            <input type='checkbox' [(ngModel)]='allSelect' (ngModelChange)=\"allSelectCheck()\">\n          </th>\n          <th class=\"table-title\" [style.width]=\"header.width\" *ngFor=\"let header of headers let j = index\" title=\"{{header.title}}\">\n            <div class=\"table-title-th\">\n              <div [ngStyle]=\"{'border-left':j===0?'none':'solid 1px #ccc'}\" class=\"text-over-flow\">{{header.title}}</div>\n              <div *ngIf=\"header.filter\" class=\"table-th-filter\">\n                <div class=\"filterBtn\" (click)=\"showFilterBox($event, header)\"></div>\n                <ng-container [ngTemplateOutlet]=\"filterTemplate\" [ngTemplateOutletContext]=\"{$implicit: header}\"></ng-container>\n              </div>\n              <div *ngIf=\"header.canSort\" class=\"table-th-sort\" (click)=\"sort(header)\" [ngClass]=\"{'asc':nowSort.field==header.field && nowSort.sort=='asc','desc':nowSort.field==header.field && nowSort.sort=='desc'}\">\n              </div>\n            </div>\n          </th>\n        </tr>\n      </thead>\n      <tbody>\n        <tr *ngFor=\"let data of datas; let i = index\">\n          <td *ngIf=\"checkBox\">\n            <input type='checkbox' [(ngModel)]='checks[i]' (ngModelChange)=\"checkSelect()\">\n          </td>\n          <td *ngFor=\"let header of headers\">\n            <ng-container [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"{$implicit: {d: data, h: header, w: setWidth(header.width)}}\"></ng-container>\n          </td>\n        </tr>\n      </tbody>\n    </table>\n\n    <ng-template #filterTemplate let-header>\n      <div *ngIf=\"header.filter.type === 'text'\" class=\"filter-box\">\n        <input type=\"text\" value=\"\" (keyup.enter)=\"clickFilter($event, header)\" placeholder=\"\u8BF7\u8F93\u5165\u7B5B\u9009\u5185\u5BB9\">\n      </div>\n      <div *ngIf=\"header.filter.type === 'checkList'\" class=\"filter-box\">\n        <ng-container *ngFor=\"let option of header.filter.optionList; let k = index\">\n          <input type='checkbox' [(ngModel)]='option.check' (ngModelChange)=\"checkOption($event, k, header)\">\n          <span>{{option.name}}</span>\n          <br/>\n        </ng-container>\n        <div>\n          <div class=\"filterSubmit\" (click)=\"sendCheckOption(header)\">\u786E\u5B9A</div>\n        </div>\n      </div>\n    </ng-template>",
            styles: [
                '.canSort {' +
                    '  cursor: pointer' +
                    '}',
                '.table-title {' +
                    '  font-size: 14px;' +
                    '}',
                'table {' +
                    '  border: none;' +
                    '}',
                'table th {' +
                    '  color: #333;' +
                    '  background-color: #fff;' +
                    '  border-bottom: 1px solid #cccccc;' +
                    '}',
                'table td {' +
                    '  border-bottom: 1px solid #e2e2e2;' +
                    '  border-top: none;' +
                    '}',
                '.sort {' +
                    '  background-image: url(/assets/img/sort.png);' +
                    '  background-repeat: no-repeat;' +
                    '  background-position: center;' +
                    '  width: 20px;' +
                    '  height: 13px;' +
                    '  display: inline-block;' +
                    '}',
                '.sort-desc {' +
                    '  background-image: url(/assets/img/sort.png);' +
                    '  background-repeat: no-repeat;' +
                    '  background-position: center;' +
                    '  width: 20px;' +
                    '  height: 13px;' +
                    '  transform: rotate(180deg);' +
                    '}',
                '.table-title-th {' +
                    '  display: flex;' +
                    '}',
                '.table-title-th>div {' +
                    '  display: inline-block;' +
                    '  margin-right: 5px' +
                    '}',
                '.table {' +
                    '  font-size: 12px;' +
                    '  color: #666 !important;' +
                    '}',
                '.table th {' +
                    '  font-size: 14px;' +
                    '  color: #333 !important;' +
                    '  line-height: 13px;' +
                    '}',
                '.table-th-sort {' +
                    '  position: relative;' +
                    '  background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAMBAMAAACtsOGuAAAAHlBMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmbpCqcMAAAACXRSTlMA5sZkORkGnJnb+QAcAAAAMElEQVQI12NgYDZgYGDwnMLAwCo5MYAhaeZMNYbOmTNnMCBA5cyZ08ESYCVgxWBtAGv8DCictG4/AAAAAElFTkSuQmCC) no-repeat left center;' +
                    '  width: 8px;' +
                    '  height: 12px;' +
                    '  top: 1px;' +
                    '  cursor: pointer;' +
                    '}',
                '.table-th-sort.asc {' +
                    '  background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAFBAMAAACKv7BmAAAAG1BMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZ8aTmeAAAACHRSTlMA5MaZYzkYBjL+0/MAAAAhSURBVAjXY2BgcWBgYIhoZWBgk2hMYCjq6FBnsOjoaAYAMaEFlaDQ04sAAAAASUVORK5CYII=) no-repeat left top;' +
                    '}',
                '.table-th-sort.desc {' +
                    '  background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAFBAMAAACKv7BmAAAAG1BMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZ8aTmeAAAACHRSTlMA58acZjkbBtcF5e8AAAAhSURBVAjXY7Do6GhmKOroUGdgk2hMYGCIaGVgYGBxYAAAWCUFlY5P/qEAAAAASUVORK5CYII=) no-repeat left bottom;' +
                    '}',
                '.table-th-filter {' +
                    '  position: relative;' +
                    '  background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAA0AAAAOBAMAAAAGUYvhAAAAKlBMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZY/DOeAAAADXRSTlMA7hHexqWBXTwhA65Xbt8TvwAAAEBJREFUCNdjiL0LAgEMyiDqsgIDB4i+wcDAkAukE4D0krt3rywA0pyydyUZQKD2bgGY5r3LgJfmkWWAAG0GBAAA/oQb9Q1/UEkAAAAASUVORK5CYII=) no-repeat left bottom;' +
                    '  width: 13px;' +
                    '  height: 14px;' +
                    '  top: 1px;' +
                    '  font-size: 12px;' +
                    '  color: #666;' +
                    '  font-weight: normal' +
                    '}',
                '.filterBtn {' +
                    '  width: 100%;' +
                    '  height: 100%;' +
                    '  display: block;' +
                    '  cursor: pointer;' +
                    '}',
                '.filter-box {' +
                    '  position: absolute;' +
                    '  left: -100%;' +
                    '  top: 20px;' +
                    '  display: none;' +
                    '  background: #fff;' +
                    '  padding: 5px;' +
                    '  box-shadow: 0px 0px 2px 1px #ccc;' +
                    '  text-indent: 0;' +
                    '  border-radius: 2px;' +
                    '  white-space: nowrap' +
                    '}',
                '.filter-box>input[type=text] {' +
                    '  width: 159px;' +
                    '  height: 26px;' +
                    '  border: solid 1px #ccc;' +
                    '  padding: 0;' +
                    '  margin: 0;' +
                    '  background: #fff;' +
                    '  transition: none;' +
                    '  text-indent: 5px;' +
                    '  font-size: 14px;' +
                    '  font-weight: normal;' +
                    '  color: #666;' +
                    '  border-radius: 2px;' +
                    '  font-size: 12px' +
                    '}',
                '.filter-box>input:focus {' +
                    '  border-color: #0081cc' +
                    '}',
                '.filter-box>input[type=checkbox], .filter-box>span {' +
                    '  display: inline-block;' +
                    '  font-size: 14px;' +
                    '  line-height: 25px;' +
                    '  text-indent: 7px' +
                    '}',
                '.filter-box>input[type=checkbox] {' +
                    '  position: relative;' +
                    '  left: 5px;' +
                    '  bottom: -2px;' +
                    '  cursor: pointer;' +
                    '}',
                '.filterSubmit {' +
                    '  padding: 0 20px;' +
                    '  text-align: center;' +
                    '  margin: 5px auto;' +
                    '  color: #fff;' +
                    '  width: 94px;' +
                    '  height: 26px;' +
                    '  line-height: 23px;' +
                    '  font-size: 14px;' +
                    '  background: #0081cc;' +
                    '  border-radius: 10px;' +
                    '  box-shadow: 0px 0px 1px 1px #ccc;' +
                    '  cursor: pointer;' +
                    '}',
                '.filterSubmit:hover {' +
                    '  background: #0067a3' +
                    '}',
                '.filterSubmit:active {' +
                    '  box-shadow: none' +
                    '}',
                '.table th,' +
                    '.table td {' +
                    '  text-align: left;' +
                    '  border-top: none;' +
                    '  padding: 20px 0 15px;' +
                    '  text-indent: 20px;' +
                    '  height: 14px;' +
                    '  line-height: 14px' +
                    '}'
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router])
    ], TableComponent);
    return TableComponent;
}());
exports.TableComponent = TableComponent;
//# sourceMappingURL=table.component.js.map